"use strict";

/* Exercice 0 : Tutoriel -- Bases du langages */ 

/* Question 1 */
// Voir, en plus de la doc MDN
//  https://javascript.info/types#type-typeof
//  https://javascript.info/instanceof
//  https://javascript.info/primitives-methods

// There are 7 primitive types: string, number, bigint, boolean, symbol, null and undefined.
// The typeof operator allows us to see which type is stored in a variable.

/* Question 3 */
// Voir, en plus de la doc MDN

// https://javascript.info/comparison#strict-equality
// A strict equality operator === checks the equality without type conversion.

/* Question 3 */
// Voir, en plus de la doc MDN

// https://javascript.info/object#copying-by-reference
// One of the fundamental differences of objects vs primitives is that they are stored and copied “by reference”.

// Primitive values: strings, numbers, booleans – are assigned/copied “as a whole value”.

/* Question 4 */
let my_object = {
  x : 42,
  y : "test",
  do : function () {console.log(this.x + " " + this.y);}
};

/* Exercice 0 : Tutoriel -- Premières fonctions */ 

function iterate_array(arr){
  console.log("for...of");
  for (let o of arr)
    console.log(o);

  console.log("for...i");
  for (let i in arr)
    console.log(arr[i]);

  console.log("for");
  for (let i = 0; i < arr.length; i++)
    console.log(arr[i]);

  console.log("while");
  let i =0;
  while (i < arr.length){
    console.log(arr[i]);
    i++;
  }

  console.log("forEach");
  arr.forEach(function(x) {console.log(x);});
}

function test(){
  iterate_array([1,2,3,6,5,4]);
  iterate_array([{a:0, b:1}, {a:1, b:42}]);
  console.log(fibonacci(10));
  if (typeof my_object.do !== "undefined")
    my_object.do();
}

function fibonacci(n){
  let arr = [0,1];
  for (let i = 2; i < n; i++)
    arr.push(arr[i-1] + arr[i-2]);
  return arr;
}

// non demandé, si on veut le faire en récursif
function fibonacci_rec(n){
  if (n == 0)
    return [];
  else
    if (n == 1)
      return [0];
    else 
      if (n == 2)
        return [0, 1];
      else{
        let r = [...fibonacci_rec(n-1)];
        r.push(r[r.length - 1] + r[r.length - 2]);
        return r;
      }
}




function tutorial_button(){
  return JSON.stringify(my_object);
}

/* Exercice 1 : 99 Bottles of Beer */ 
function bottles(beers){
  console.log('[js] bottles (OK) (' + beers +')');
  
  let res = "";
  for (let i = beers; i > 1; --i){
    res +=  `${i} bottles of beer on the wall, ${i} bottles of beer. <br>`;
    res +=  `Take one down and pass it around, ${i-1} bottles of beer on the wall. <br><br>`;
  }

  if (beers >= 1){
    res += `1 bottle of beer on the wall, 1 bottle of beer. <br>`;
    res += `Take one down and pass it around, no more bottles of beer on the wall. <br><br>`;
  }

  res += `No more bottles of beer on the wall, no more bottles of beer. <br>`;
  res += `Go to the store and buy some more, ${beers} bottles of beer on the wall.`;
  
  return res;
}
  
/* Exercice 2 : fonction range */
function range(stop, start, step) {
  console.log('[js] range(' + stop  + ',' + start  +',' + step + ')');
  var res = [];
  start = typeof start  !== 'undefined' ? start  : 0;
  step  = typeof step  !== 'undefined' ? step  : 1;

  for(var i = start; (i < stop) ; i+=step)
    res.push(i);

  console.log('[js] range(' + stop + ',' + start +',' + step + ')=' + res);  
  return res;
}

// En version récursive
function range_rec(stop, start = 0, step = 1) {
  if (!Number.isInteger(step) || step < 1) return [];

  // condition d'arrêt de la récursion
  if (stop <= start) return [];

  // on renvoie le tableau [start] auquel on concantene les autres nombres obtenus par l'appel récursif
  return [start].concat(range_rec(stop, start + step, step));
}

/* Exercice 3 : Calculatrice polonaise inverse */
let evaluate = function(expr) {
  console.log('[js] evaluate (' + expr +')');
  let atoms = expr.split(' ');
  let results = [];
  let cur = "";
  
  const converter = {
    '+': function (x,y) {return y+x;},
    '-': function (x,y) {return y-x;},
    '*': function (x,y) {return y*x;},
    '/': function (x,y) {return y/x;},
  };
  
  for (let i=0; i<atoms.length; i++) {
    cur = atoms[i].trim();
    if(!isNaN(parseFloat(cur))) {
      results.push(parseFloat(cur));
    }
    else
      results.push(converter[cur](results.pop(), results.pop()));
  }
  
  return results.pop() || 0;
}
  
document.addEventListener('DOMContentLoaded', function(){ 
  /* Exercice 0 : tutoriel */
   let output0  = document.getElementById("output0");

   document.getElementById("eval0").onclick = function() {
    output0.innerHTML = tutorial_button();
  };
  
  /* Exercice 1 : 99 Bottles of Beer */
   let output1 = document.getElementById("output1");
   let input1 = document.getElementById("input1");
   
   document.getElementById("eval1").onclick = function() {
    output1.innerHTML = bottles(input1.value);
	};
  
   /* Exercice 2 : fonction range */
  let output2 = document.getElementById("output2");
	let input2stop = document.getElementById("input2stop");
  let input2start = document.getElementById("input2start");
  let input2step = document.getElementById("input2step");
  
  document.getElementById("reset2").onclick = function(){
    input2stop.value = 10;
    input2start.value = "";
    input2step.value = "";
		output2.innerHTML = "";
	};

  document.getElementById("eval2").onclick = function() {
    let stop = Number(input2stop.value);
    let start = (input2start.value!=="")?Number(input2start.value):undefined;
    let step = (input2step.value!=="")?Number(input2step.value):undefined;
    
    output2.innerHTML += '[' + String(range(stop, start, step))+']<br>';
  };
  
   /* Exercice 3 : Calculatrice polonaise inverse */   
	let output3 = document.getElementById("output3");
	let input3 = document.getElementById("input3");

	document.getElementById("reset3").onclick = function(){
		output3.innerHTML = "";
	};
  
	document.getElementById("eval3").onclick = function() {
		let res = evaluate(input3.value);
		output3.innerHTML += (String(res) + '<br>');
	};

}, false);

